
-- return the window size
getWindowSize = getWindowSize or function()
	return 630, 200
end

-- create and lay out all the controls
createUI = createUI or function()

	createUICommon()

	-- constants
	local kKnobSpace = 43
	local kWideTextW = 40

	-- make groups and knobs
	--
	
	local x = 0

	theKnobRenderer = smallKnobRenderer

	targetGroup = group( "Target" )
	x = 0
	labelledDropDown( targetGroup, "Target Hardware", "Hardware",	x, 0 )
	x = x + kDropdownW + pad
	labelledDropDown( targetGroup, "Target Channel", "Channel",		x, 0 )
	x = x + kDropdownW + pad

	inputsGroup = group( "Inputs" )
	local kInputsW = 40
	local kInputsY = kTextFieldH + 20
	x = 0
	labelledDropDown( inputsGroup, "Input Thru", "Thru",		x, kInputsY, kInputsW )
	x = x + kInputsW + 10
	for i=1,8 do
		labelledDropDown( inputsGroup, "Input " .. i, "" .. i,		x, kInputsY, kInputsW )
		inputsGroup:add( paramButton( "Filter " .. i, "Filter",	x, 0, kInputsW, kTextFieldH ) )
		x = x + kInputsW + 10
	end

	miscGroup = group( "Misc" )
	x = 0
	smallKnobAndTextField( miscGroup, "Test Signal",	"Test",		x, 0 )
	miscGroup:setVisible( showTestSignals )

	interfaceGroup = group( "Interface" )
	x = 0
	labelledDropDown( interfaceGroup, "Interface Category", "Category",		x, 0 )

	oscGroup = group( "OSC" )
	smallKnobAndTextField( oscGroup, "OSC Port Offset",	"Port",		0*kKnobSpace, 0 )
	oscGroup:setVisible( false )

	offsetsGroup = group( "Offsets" )
	x = 0
	for i=1,8 do
		knobAndTextField( offsetsGroup, "Offset " .. i,		"" .. i,		x, 0, kKnobSize, kTextFieldH, kWideTextW, "%.3f" )
		x = x + kWideTextW + pad
	end

	-- positions!

	local xbase = windowEdgePad
	local ybase = windowEdgePad
	local x = xbase
	local y = ybase

	local top = ybase + offsetsGroup:height() + pad + inputsGroup:height()

	y = top - targetGroup:height()
	targetGroup:setPosition( x, y, true )
	y = y - pad - interfaceGroup:height()
	interfaceGroup:setPosition( x, y, true )
	local smuxy = y - pad

	x = x + targetGroup:width() + pad

	y = ybase
	offsetsGroup:setPosition( x + inputsGroup:width() - offsetsGroup:width(), y, true )

	inputsGroup:setPosition( x, top - inputsGroup:height(), true )

	x = x - miscGroup:width() + pad
	miscGroup:setPosition( x, y, true )

	-- add directly positioned objects
	--
	
	x = xbase
	y = smuxy - kTextFieldH
	add( paramButton( "SMUX Proof", "SMUX Proof",	x, y, 100, kTextFieldH ) )
	y = y - kTextFieldH - pad
	add( paramButton( "Adaptive Mode", "Adaptive Mode",	x, y, 100, kTextFieldH ) )

end		-- of createUI()
